var $ = jQuery;
$(function() {


    var jGroupSelect = $("select.SelectStudyGroup");

    var jAppPrototype = $($.parseHTML (   "<div class='AttachedGroup'> \
                                            <div class='StudyGroupInfo'></div> \
                                            <button class='UnbindGroup'>Отсоединить группу</button> \
                                            </div>"
                                        ));


    function GetAppendedElement(id, studyGroupName){
        var cell = jAppPrototype.clone();
        cell.attr("id", id);
        cell.children("div.StudyGroupInfo").html(studyGroupName);
        return cell;
    }

    // Прикрепить группу
    $("button.AttachGroupButton").click(function()
    {
        var jThis = $(this);
        var studyGroupID = parseInt(jGroupSelect.val());
        if (studyGroupID <= 0) 
            return;
        var jSelected = jGroupSelect.children("option:selected");
        var studyGroupName = jSelected.text();
        $(this).attr("disabled", true);
        $.post(
            g_URLdir + "handler/map/BindGroup",
            {
                "StudyGroupID": studyGroupID,
                "DisciplineID": g_disciplineID
            },
            function(data)
            {
                data = $.parseJSON(data);
                if(data.success === true) {
                    var flag = false;
                    //TODO: too slow
                    jGroupSelect.parent().next().children("div.AttachedGroup").each(function() {
                        if ($(this).children(".StudyGroupInfo").html().localeCompare(studyGroupName) === 1) {
                            $(this).before(GetAppendedElement(studyGroupID, studyGroupName));
                            flag = true;
                            return false;
                        }
                        return true;
                    });
                    if (!flag) {
                        jGroupSelect.parent().next().append(GetAppendedElement(studyGroupID, studyGroupName));
                    }
                }
                else
                    if (parseInt(data.code) === 1)
                        EventInspector_ShowMsg("Группа уже прикреплена", "error");
                    else    
                        EventInspector_ShowMsg("Ошибка при добавлении группы", "error");
                
                jThis.removeAttr("disabled");
            }
        );
    });

    // Отсоединить группу
    $("div.AttachedGroupsList").on("click", ".UnbindGroup:not(disabled)", function()
    {
        var jThis = $(this);
        var GroupDIV = $(this).parent();
        var studyGroupID = GroupDIV.attr("id");
        //var Name = $(this).siblings(".StudyGroupInfo").html();
        $(this).attr("disabled", true);
        $.post(
            g_URLdir + "handler/map/UnbindGroup",
            {
                "StudyGroupID": studyGroupID,
                "DisciplineID": g_disciplineID
            },
            function(data)
            {
                data = $.parseJSON(data);
                if(data.success === true) {
                    GroupDIV.remove();
                }
                else {
                    EventInspector_ShowMsg("Ошибка при отсоединении группы", "error");
                    jThis.removeAttr("disabled");
                }
            }   
        );
    });


});
